<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 25.60 Lấy danh sách tất cả đơn hàng và hiện thành bảng </title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="form-group text-center">
        <h4>Danh sách đơn hàng</h4>
    </div>
    <div class="row form-group">
        <div class="col-12 ">
            <table class=" table table-bordered table-striped table-hover" id="table-order-list">
                <thead>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gEND_ROW_TABLE = -1;
    const gCELL_ORDER_CODE = 0;
    const gCELL_KICH_CO = 1;
    const gCELL_LOAI_PIZZA = 2;
    const gCELL_NUOC_UONG = 3;
    const gCELL_THANH_TIEN = 4;
    const gCELL_FULL_NAME = 5;
    const gCELL_PHONE = 6;
    const gCELL_TRANG_THAI = 7;
    const gCELL_CHI_TIET = 8;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện load trang
    function onPageLoading() {
        goiApiOder();
    }
    // Hàm sự kiện khi nút detail click
    function onBtnDetailClick(paramDetail) {
        //  lấy dữ liệu dataset
        var vId = paramDetail.dataset.id;
        var vOrderCode = paramDetail.dataset.ordercode;
        // send data vào console
        console.log("Id:" + vId);
        console.log("orderCode:" + vOrderCode);
        const vDETAIL = "viewOderDetail.html"
        var vUrl = vDETAIL +
            "?orderCode=" + vOrderCode +
            "&id=" + vId;
        window.location.href = vUrl;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi Api get all orders
    function goiApiOder() {
        var vXmlHttpGetAllOrder = new XMLHttpRequest();
        vXmlHttpGetAllOrder.open("GET", gBASE_URL, true);
        vXmlHttpGetAllOrder.send();
        vXmlHttpGetAllOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    hienThiDuLieuDonHang(vXmlHttpGetAllOrder);
                }
            }
    }
    // Hàm hiển thị dữ liệu vào bảng
    function hienThiDuLieuDonHang(paramXmlHttp) {
        // Ghi responseText ra console
        console.log(paramXmlHttp.responseText);
        // parsing dữ liệu thành object
        var vOrderList = JSON.parse(paramXmlHttp.responseText);
        // Truy vấn bảng table
        var vTable = document.getElementById("table-order-list");
        // lấy danh sách các phần tử trong thẻ thead
        var vTableHead = document.getElementsByTagName("thead")[0];
        // xóa dòng tiêu đề
        vTableHead.innerHTML = "";
        // Tạo hàng cho dòng tiêu đề
        var vNewRowTD = vTableHead.insertRow(gEND_ROW_TABLE);
        // Thêm cột cho hàng tiêu đề
        var vNewCellOrderCodeTD = vNewRowTD.insertCell(gCELL_ORDER_CODE);
        var vNewCellKichCoTD = vNewRowTD.insertCell(gCELL_KICH_CO);
        var vNewCellLoaiPizzaTD = vNewRowTD.insertCell(gCELL_LOAI_PIZZA);
        var vNewCellDrinkTD = vNewRowTD.insertCell(gCELL_NUOC_UONG);
        var vNewCellPriceTD = vNewRowTD.insertCell(gCELL_THANH_TIEN);
        var vNewCellFullNameTD = vNewRowTD.insertCell(gCELL_FULL_NAME);
        var vNewCellPhoneTD = vNewRowTD.insertCell(gCELL_PHONE);
        var vNewCellTrangThaiTD = vNewRowTD.insertCell(gCELL_TRANG_THAI);
        var vNewCellChiTietTD = vNewRowTD.insertCell(gCELL_CHI_TIET);

        vNewCellOrderCodeTD.innerHTML = "OderCode";
        vNewCellKichCoTD.innerHTML = "Kích cỡ combo";
        vNewCellLoaiPizzaTD.innerHTML = "Loại pizza";
        vNewCellDrinkTD.innerHTML = "Nước uống";
        vNewCellPriceTD.innerHTML = "Thành tiền";
        vNewCellFullNameTD.innerHTML = "Họ và tên";
        vNewCellPhoneTD.innerHTML = "Số điện thoại";
        vNewCellTrangThaiTD.innerHTML = "Trạng thái";
        vNewCellChiTietTD.innerHTML = "Chi tiết";
        // lấy danh sách các phần tử trong thẻ tbody
        var vTableBody = document.getElementsByTagName("tbody")[0];
        vTableBody.innerHTML = "";
        for (var bI = 0; bI < vOrderList.length; bI++) {
            // Tạo hàng mơi cho dòng body
            var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
            // Thêm cột cho hàng
            var vNewCellOrderCode = vNewRow.insertCell(gCELL_ORDER_CODE);
            var vNewCellKichCo = vNewRow.insertCell(gCELL_KICH_CO);
            var vNewCellLoaiPizza = vNewRow.insertCell(gCELL_LOAI_PIZZA);
            var vNewCellDrink = vNewRow.insertCell(gCELL_NUOC_UONG);
            var vNewCellPrice = vNewRow.insertCell(gCELL_THANH_TIEN);
            var vNewCellFullName = vNewRow.insertCell(gCELL_FULL_NAME);
            var vNewCellPhone = vNewRow.insertCell(gCELL_PHONE);
            var vNewCellTrangThai = vNewRow.insertCell(gCELL_TRANG_THAI);
            var vNewCellChiTiet = vNewRow.insertCell(gCELL_CHI_TIET);

            var vOrder = vOrderList[bI];
            vNewCellOrderCode.innerHTML = vOrder.orderCode;
            vNewCellKichCo.innerHTML = vOrder.kichCo;
            vNewCellLoaiPizza.innerHTML = vOrder.loaiPizza;
            vNewCellDrink.innerHTML = vOrder.idLoaiNuocUong;
            vNewCellPrice.innerHTML = vOrder.thanhTien;
            vNewCellFullName.innerHTML = vOrder.hoTen;
            vNewCellPhone.innerHTML = vOrder.soDienThoai;
            vNewCellTrangThai.innerHTML = vOrder.trangThai;
            // Tạo ra button chi tiết
            var vDetailButton = document.createElement("button");
            vDetailButton.innerHTML = "Chi tiết";
            vDetailButton.className = "btn btn-info";
            // Gắn dữ liệu cho các thuộc tính dataset của nút
            vDetailButton.setAttribute("data-id", vOrder.id);
            vDetailButton.setAttribute("data-ordercode", vOrder.orderCode);
            vNewCellChiTiet.appendChild(vDetailButton);
            // Thêm sự kiện cho nút 
            vDetailButton.addEventListener("click", function () {
                onBtnDetailClick(this);
            });
        }
    }
</script>

</html>